#include <stdio.h>
#include <dlfcn.h>	/* wg. dlopen(), ... */

int main() {
    void *handle;
    void (*hallo)(char*,char*); /* Zeiger fuer die Funktion hallo() */

	/* dyn. Bibliothek (shared object) oeffnen */
    if (!(handle = dlopen("libown.so", RTLD_LAZY))) {
	fprintf(stderr, "%s\n", dlerror());
	return 1;
    }
    
	/* Zeiger auf Funktion in dyn. Bibliothek (shared object) beschaffen */
    if (!(hallo = dlsym(handle, "hallo"))) {
	fprintf(stderr, "%s\n", dlerror());
	return 1;
    }
    
    (*hallo)("Johannes", "Mayer");

	/* dyn. Bibliothek (shared object) wieder schliessen */
    dlclose(handle);
    
    return 0;
}
