#ifndef STACK_H
#define STACK_H

    /* abstrakter Datentyp */
typedef struct _stack *Stack;

    /* Stack-Elemente */
typedef void *ELEMENT;

typedef int BOOL;

    /* Kopierfunktion fuer die Stack-Elemente */
typedef ELEMENT (*COPYFUN)(ELEMENT);

extern void newStack(Stack *s, COPYFUN cp);
extern void deleteStack(Stack *s);
extern BOOL isEmpty(Stack s);
extern ELEMENT pop(Stack s);
extern void push(Stack s, ELEMENT elem);

#endif
