#include "complex.h"
#include <stdio.h>
#include <stdlib.h>

struct _complex {
    FLOAT _re, _im;
};

void newComplex(Complex *c, FLOAT re, FLOAT im) {
    *c = (Complex) calloc(1, sizeof(struct _complex));
    if (*c != NULL) {	/* bei Erfolg ... ;-) */
	(*c)->_re = re;
	(*c)->_im = im;
    }
}

void deleteComplex(Complex *c) {
    free(*c);
    *c = NULL;
}

FLOAT real(Complex c) {
    return c->_re;
}

FLOAT imag(Complex c) {
    return c->_im;
}

Complex add(Complex a, Complex b) {
    Complex tmp;
    newComplex(&tmp, a->_re, a->_im);
    if (tmp != NULL) {
	tmp->_re += b->_re;
	tmp->_im += b->_im;
    }
    return tmp;	/* nur Zeiger ist lokal! Objekt auf dem Heap! */
}

void print(Complex c) {
    printf("%f + i * %f\n", c->_re, c->_im);
}
