#include "complex.h"
#include <stdio.h>

int main() {
    Complex a, b, c;

    newComplex(&a, 3, 4);
    newComplex(&b, -1, 2);
    
    if (a == NULL || b == NULL) {
	fprintf(stderr, "not enough memory\n");
	return 1;
    }

    print(a);
    print(b);
    
    c = add(a, b);
    
    if (c == NULL) {
	fprintf(stderr, "not enough memory\n");
	return 1;
    }
    
    print(c);
    
    deleteComplex(&a);
    deleteComplex(&b);
    deleteComplex(&c);
    
    return 0;
}
